/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package deeper.operators.treesvm;

import com.rapidminer.example.Attribute;
import com.rapidminer.example.Attributes;
import com.rapidminer.example.Example;
import com.rapidminer.example.ExampleSet;
import com.rapidminer.example.table.NominalMapping;
import com.rapidminer.operator.learner.functions.kernel.jmysvm.kernel.Kernel;
import deeper.entities.graph.Edge;
import deeper.entities.graph.Graph;
import deeper.entities.graph.Node;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.Collection;
import java.util.Iterator;

/**
 *
 * @author tfairuzo
 */
@Deprecated
public class KernelTree extends Kernel {

    /**
	 * 
	 */
	private static final long serialVersionUID = -7806756421452594121L;
	
	private double lambda = 0.4;
    private Attribute[] attributes;
    private ExampleSet exSet;

    /** Class constructor. */
    public KernelTree() {
    }

    public void setParameters(double lambda, ExampleSet exampleSet) {
        this.lambda = lambda;
        exSet = exampleSet;
        this.attributes = new Attribute[exSet.getAttributes().allSize()];
        Iterator<Attribute> i = exSet.getAttributes().allAttributes();
        int j = 0;
        while(i.hasNext()){
            this.attributes[j++]=i.next();
        }
    }

    @Override
    public double calculate_K(int[] x_index, double[] x_values, int[] y_index, double[] y_values) {
        double result = 0;
        int xpos = x_index.length - 1;
        int ypos = y_index.length - 1;
        
        /*while ((xpos >= 0) && (ypos >= 0)) {
            if (x_index[xpos] == y_index[ypos]) {
                //assumes that a feature vector contains only tree attributes
                //TODO: add attribute check for a tree type
            	String idx = the_examples.getId(exNx);
            	String idy = the_examples.getId(exNy);
            	Example x = exSet.getExampleFromId(exSet.getAttributes().getId().getMapping().getIndex(idx));
            	Example y = exSet.getExampleFromId(exSet.getAttributes().getId().getMapping().getIndex(idy));
                //String tree1 = attributes[x_index[xpos]].getMapping().mapIndex((int)x_values[xpos]);
                //String tree2 = attributes[y_index[ypos]].getMapping().mapIndex((int)y_values[ypos]);
            	Attribute att = attributes[x_index[xpos]];
            	//Attribute atty = attributes[y_index[ypos]];
            	String tree1 = att.getMapping().mapIndex((int)x.getValue(att));
            	String tree2 = att.getMapping().mapIndex((int)y.getValue(att));

				try {
					Graph path1 = Graph.deserialize(new BufferedReader(new StringReader(tree1)));
	                Graph path2 = Graph.deserialize(new BufferedReader(new StringReader(tree2)));
	                result += Cm(path1.getRoot(), path2.getRoot(), path1, path2); 
				} catch (IOException e) {
					e.printStackTrace();
				}
                	//x_values[xpos] * y_values[ypos];
                xpos--;
                ypos--;
            } else if (x_index[xpos] > y_index[ypos]) {
                xpos--;
            } else {
                ypos--;
            }
        }
*/
        return result;
    }

    public double Cm(Node v1, Node v2, Graph g1, Graph g2) {
        double result = 1;
        if(v1==null||v2==null){
        	//no path - no similarity
        	return 0;
        }
        if ((v1.word==null && v2.word==null) || 
        		((v1.word!=null && v2.word!=null) && v1.word.equals(v2.word))) {
            Collection<Edge> out1 = g1.getOutEdges(v1);
            Collection<Edge> out2 = g2.getOutEdges(v2);
            if (out1.size() > 0 && out2.size() > 0) {
                for (Edge e1 : out1) {
                    for (Edge e2 : out2) {
                        if ((e1.label==null && e2.label==null) || 
                        		((e1.label!=null && e2.label!=null) && e1.label.equals(e2.label))) {
                            //TODO: lambda parameter is not taken into account
                            result *= (Cm(g1.getDest(e1), g2.getDest(e2), g1, g2) + 2);
                        }
                    }
                }
            }
        }
        result--;
        return result;
    }

    @Override
    public String getDistanceFormula(double[] doubles, String[] strings) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
