package deeper.entities.rm.io;

import java.util.List;

import com.rapidminer.operator.ResultObjectAdapter;

import deeper.entities.TextData;
import deeper.entities.TextDataPiece;

public class TextDataIO<T extends TextDataPiece> extends ResultObjectAdapter{

	private static final long serialVersionUID = 2041378603559754524L;
	
	private TextData<T> data = new TextData<T>();
	
	public TextDataIO(){}

	public TextDataIO(List<T> result) {
		data.addAll(result);
	}
	
	public TextDataIO(TextData<T> result) {
		data = result;
	}
	
	public void addElement(T abst){
		data.add(abst);
	}
	
	public TextData<T> getData(){
		return data;
	}
}
